`include "pll.v"
`include "system.v"

module main(
	output TXD, 
	input  RXD, 
	input  CLKIN, 

	inout  [15:0]XD,
	output [15:0]XA,
	output XWE,
	output XOE,
	output XBHE,
	output XBLE,
	
	input  MISO,
	output MOSI,
	output SCK,
	output SSBF,
		
	output [2:0]LED,
	
	output HSYN,
	output VSYN,
	output R,
	output G,
	output B,
	output I

);
wire XBHE;
wire XBLE;
assign XBHE=0;
assign XBLE=0;

wire clk,pll_lock;

//-- Instanciar el PLL
pll
  pll1(
	.clock_in(CLKIN),
	.clock_out(clk),
	.locked(pll_lock)
	);

//assign clk = CLKIN;

// Reset
parameter NRES=22;
reg [NRES-1:0]cres=0;
always @(posedge CLKIN) cres<=cres[NRES-1]?cres:cres+1;
assign resb=cres[NRES-1];

SYSTEM #(.FCLK(25125000), .BAUD(115200)) sys0( .clk(clk), .reset( ~resb), .txd(TXD), .rxd(RXD),
	.xoeb(XOE), .xweb(XWE), .xd(XD), .xa(XA),
	.led(led),
	.hsyn(HSYN), .vsyn(VSYN), .video({I,R,G,B})

 );

wire [7:0]led;

assign LED=led[2:0];
endmodule


