`include "plls.v"
`include "system.v"

module main(
	output TXD, 
	input  RXD, 
	input  CLKIN, 

	inout  [15:0]XD,
	output [15:0]XA,
	output XWE,
	output XOE,
	output XBHE,
	output XBLE,
	
	input  MISO,
	output MOSI,
	output SCK,
	output SSBF,

	output PWM,
	
	output HSYN,
	output VSYN,
	output [3:0]R,
	output [3:0]G,
	output [3:0]B
);

assign XBHE=0;
assign XBLE=0;
assign PWM=0;

wire clk,pll_lock;

//-- Instanciar el PLL
pll
  pll1(
	.clock_in(CLKIN),
	.clock_out(clk),
	.locked(pll_lock)
	);

//assign clk = CLKIN;

// Reset
parameter NRES=22;
reg [NRES-1:0]cres=0;
always @(posedge CLKIN) cres<=cres[NRES-1]?cres:cres+1;
assign resb=cres[NRES-1];

SYSTEM #(.FCLK(25000000), .BAUD(115200)) sys0( .clk(clk), .reset( ~resb), .txd(TXD), .rxd(RXD),
	.xoeb(XOE), .xweb(XWE), .xd(XD), .xa(XA),
	.hsyn(HSYN), .vsyn(VSYN), .video({i,r,g,b})
 );
wire i,r,g,b;

assign R = {r,i,r,r};
assign G = {g,i,g,g};
assign B = {b,i,b,b};


endmodule


